		.MODEL	SMALL

;---------------------------------------;
		.DATA
;---------------------------------------;

Random_Seed	DW	1
Save_Stack	DW	0
Stack_OK	DB	'Stack contains no information',13,10,'$'
Stack_BAD	DB	' Bytes on Stack',13,10,'$'
Dump_Header	DB	'REG',9,'HEX',9,'UnSign',9,'Signed',13,10,'----',9,'----',9,'------',9,'------',13,10,'$'

;---------------------------------------;
		.CODE
;---------------------------------------;

		PUBLIC	Start_Stack
		PUBLIC	Check_Stack
		PUBLIC	Text80x25
		PUBLIC	Keyboard_Flush
		PUBLIC	Keyboard_Wait
		PUBLIC	Keypressed
		PUBLIC	ReadKey
		PUBLIC	Delay
		PUBLIC	PrintASCII
		PUBLIC	PrintBEEP
		PUBLIC	PrintBLANK
		PUBLIC	PrintTAB
		PUBLIC	PrintMINUS
		PUBLIC	PrintCRLF
		PUBLIC	PrintHEX
		PUBLIC	PrintBYTE
		PUBLIC	PrintNYBBLE
		PUBLIC	PrintBIN
		PUBLIC	PrintSigned
		PUBLIC	PrintUnsigned
		PUBLIC	PrintFraction
		PUBLIC	PrintDump
		PUBLIC	Random_Initialize
		PUBLIC	Random_Randomize
		PUBLIC	Random_Set_Seed
		PUBLIC	Random_Get_New
		PUBLIC	Upper_Case
		PUBLIC	Lower_Case
		PUBLIC	SQRT_Signed
		PUBLIC	SQRT_Unsigned

;---------------------------------------;
; Call Start_Stack at the beginning of
; the program, and call Check_Stack at
; the end.  If there is any difference,
; the Check_Stack routine will print out
; the number of bytes left on stack.
; Note that the calls to both routines
; push a return address on the stack,
; but since both do it the same way,
; there should not be any difference if
; all other code is OK.
; Note that registers are NOT saved.
;---------------------------------------;

Start_Stack	PROC	NEAR
		MOV	Save_Stack,SP
		RET
Start_Stack	ENDP

;---------------------------------------;

Check_Stack	PROC	NEAR
		CMP	SP,Save_Stack
		MOV	DX,OFFSET Stack_OK
		JZ	Stack0
		MOV	DX,OFFSET Stack_Bad
		MOV	AX,Save_Stack
		SUB	AX,SP
		CALL	PrintUnsigned
        Stack0:	MOV	AH,9
		INT	21H
		RET
Check_Stack	ENDP

;---------------------------------------;
; Reset Screen to 80x25 Text Mode
;---------------------------------------;

Text80x25	PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX

		MOV	AX,0003H
		INT	10H

		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
Text80x25	ENDP

;---------------------------------------;
; Flush all keys from the keyboard buffer
;---------------------------------------;

Keyboard_Flush	PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX

    Flush_Loop:
		MOV	AX,0100H
		INT	16H
		JZ	Flush_Done
;		MOV	AX,0B00H	; KeyPressed
;		INT	21H		;
;		CMP	AL,0		;
;		JE	Flush_Done	;
		MOV	AX,0700H	; ReadKey (No ^C check)
		INT	21H		;
		JMP	Flush_Loop	;
    Flush_Done:				;

		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
Keyboard_Flush	ENDP

;---------------------------------------;
; Wait until a key is waiting to be read
;---------------------------------------;

Keyboard_Wait	PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX

 Wait_Key_Loop:
		MOV	AX,0100H
		INT	16H
		JZ	Wait_Key_Loop

;		MOV	AX,0B00H
;		INT	21H
;		CMP	AL,0
;		JE	Wait_Key_Loop

		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
Keyboard_Wait	ENDP

;---------------------------------------;
; Carry := Keypressed
;---------------------------------------;

Keypressed	PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX

		MOV	AX,0100H
		INT	16H
		JZ	NoKey
		STC
		JMP SHORT EndKey
	NoKey:	CLC
	EndKey:	

;		MOV	AX,0B00H
;		INT	21H
;		CMP	AL,0
;		CLC
;		JE	NoKey
;		CMC
;	 NoKey:

		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
Keypressed	ENDP

;---------------------------------------;
; AX := ReadKey (high byte zero)
;---------------------------------------;

ReadKey		PROC	NEAR
		PUSH	BX
		PUSH	CX
		PUSH	DX

		MOV	AX,0700H	; AL := ReadKey (no ^C check)
		INT	21H		;
		XOR	AH,AH		;

		POP	DX
		POP	CX
		POP	BX
		RET
ReadKey		ENDP

;---------------------------------------;
; Delays number of milliseconds in AX	;
;---------------------------------------;

Delay		PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX

		MOV	BX,1000
		MUL	BX
		MOV	CX,DX
		MOV	DX,AX
		MOV	AX,8600H
		INT	15H

		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
Delay		ENDP

;---------------------------------------;
; Print character in AL
;---------------------------------------;

PrintASCII	PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX

		MOV	DL,AL
		MOV	AH,2
		INT	21H

		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
PrintASCII	ENDP

;---------------------------------------;
; Ring the Bell
;---------------------------------------;

PrintBEEP	PROC	NEAR
		PUSH	AX
		MOV	AX,7
		CALL	PrintASCII
		POP	AX
		RET
PrintBeep	ENDP

;---------------------------------------;
; Print " "
;---------------------------------------;

PrintBLANK	PROC	NEAR
		PUSH	AX
		MOV	AX,' '
		CALL	PrintASCII
		POP	AX
		RET
PrintBLANK	ENDP

;---------------------------------------;
; Print " "
;---------------------------------------;

PrintTAB	PROC	NEAR
		PUSH	AX
		MOV	AX,9
		CALL	PrintASCII
		POP	AX
		RET
PrintTAB	ENDP

;---------------------------------------;
; Print "-"
;---------------------------------------;

PrintMINUS	PROC	NEAR
		PUSH	AX
		MOV	AX,'-'
		CALL	PrintASCII
		POP	AX
		RET
PrintMINUS	ENDP

;---------------------------------------;
; Print Carriage Return - Line Feed
;---------------------------------------;

PrintCRLF	PROC	NEAR
		PUSH	AX
		MOV	AX,13
		CALL	PrintASCII
		MOV	AX,10
		CALL	PrintASCII
		POP	AX
		RET
PrintCRLF	ENDP

;---------------------------------------;
; Print AX as four Hex characters
;---------------------------------------;

PrintHEX	PROC	NEAR
		PUSH	AX
		MOV	AL,AH
		CALL	PrintByte
		POP	AX
		PUSH	AX
		CALL	PrintByte
		POP	AX
		RET
PrintHEX	ENDP

;---------------------------------------;
; Print AL as two Hex characters
;---------------------------------------;

PrintBYTE	PROC	NEAR
		PUSH	AX
		SHR	AX,1
		SHR	AX,1
		SHR	AX,1
		SHR	AX,1
		CALL	PrintNYBBLE
		POP	AX
		PUSH	AX
		CALL	PrintNYBBLE
		POP	AX
		RET
PrintBYTE	ENDP

;---------------------------------------;
; Print low 4 bits of AL as Hex character
;---------------------------------------;

PrintNYBBLE	PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX

		AND	AX,000FH
		CMP	AX,9
		JLE	PrCorrect
		ADD	AX,'A'-'0'-10	
     PrCorrect:	ADD	AX,'0'

		MOV	DL,AL
		MOV	AH,2
		INT	21H

		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
PrintNYBBLE	ENDP

;---------------------------------------;
; Print AX as 16 bit Binary number
;---------------------------------------;

PrintBIN	PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX

		MOV	CX,16
		MOV	BX,AX
    PrBIN_Loop:	SHL	BX,1
		MOV	DL,'0'
		ADC	DL,0
		MOV	AH,2
		PUSH	BX
		PUSH	CX
		INT	21H
		POP	CX
		POP	BX
		LOOP	PrBIN_Loop

		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
PrintBIN	ENDP

;---------------------------------------;
; Print (AX) in decimal, signed
;---------------------------------------;

PrintSigned	PROC	NEAR
		PUSH	AX

		CMP	AX,0
		JGE	Is_Pos
		CALL	PrintMINUS
		NEG	AX
	Is_Pos:	CALL	PrintUnsigned

		POP	AX
		RET
PrintSigned	ENDP

;---------------------------------------;
; Print AX in decimal
;---------------------------------------;

PrintUnsigned	PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX

		MOV	BX,10
		MOV	CX,0
      Div_Loop:	MOV	DX,0
		IDIV	BX
		ADD	DX,'0'
		PUSH	DX
		INC	CX
		CMP	AX,0
		JNZ	Div_Loop

      Pop_Loop:	POP	AX
		CALL	PrintASCII
		LOOP	Pop_Loop

		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
PrintUnsigned	ENDP

;---------------------------------------;
; Print .AX in decimal (pure fraction)
;---------------------------------------;

PrintFraction	PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX

		PUSH	AX
		MOV	AX,'.'
		CALL	PrintASCII
		POP	AX

		MOV	BX,10

     Frac_Loop:	MUL	BX
		PUSH	AX
		MOV	AX,DX
		ADD	AX,'0'
		CALL	PrintASCII
		POP	AX
		OR	AX,AX
		JNZ	Frac_Loop

		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
PrintFraction	ENDP

;---------------------------------------;
; Dumps all registers			;
;---------------------------------------;

PrintDump	PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX
		PUSH	SI
		PUSH	DI
		PUSH	BP

		PUSH	AX
		PUSH	DX

		MOV	DX,OFFSET Dump_Header
		MOV	AH,9
		INT	21H

		MOV	AX,'A'
		CALL	PrintASCII
		MOV	AX,'X'
		CALL	PrintASCII

		POP	DX
		POP	AX

		CALL	Dump_AX

		MOV	AX,'B'
		CALL	PrintASCII
		MOV	AX,'X'
		CALL	PrintASCII
		MOV	AX,BX
		CALL	Dump_AX

		MOV	AX,'C'
		CALL	PrintASCII
		MOV	AX,'X'
		CALL	PrintASCII
		MOV	AX,CX
		CALL	Dump_AX

		MOV	AX,'D'
		CALL	PrintASCII
		MOV	AX,'X'
		CALL	PrintASCII
		MOV	AX,DX
		CALL	Dump_AX

		MOV	AX,'S'
		CALL	PrintASCII
		MOV	AX,'I'
		CALL	PrintASCII
		MOV	AX,SI
		CALL	Dump_AX

		MOV	AX,'D'
		CALL	PrintASCII
		MOV	AX,'I'
		CALL	PrintASCII
		MOV	AX,DI
		CALL	Dump_AX

		MOV	AX,'B'
		CALL	PrintASCII
		MOV	AX,'P'
		CALL	PrintASCII
		MOV	AX,BP
		CALL	Dump_AX

		MOV	AX,'S'
		CALL	PrintASCII
		MOV	AX,'P'
		CALL	PrintASCII
		MOV	AX,SP
		ADD	AX,16
		CALL	Dump_AX


		CALL	PrintCRLF

		MOV	BP,SP		; Step Over all saved registers
		ADD	BP,16		; and return address, to get to old stack

		MOV	AX,'S'
		CALL	PrintASCII
		MOV	AX,'P'
		CALL	PrintASCII
		CALL	PrintMINUS
		CALL	PrintMINUS
		MOV	AX,'>'
		CALL	PrintASCII

		MOV	AX,[BP]
		CALL	Dump_AX
		MOV	AX,[BP+2]
		CALL	Dump_AX
		MOV	AX,[BP+4]
		CALL	Dump_AX
		MOV	AX,[BP+6]
		CALL	Dump_AX

		CALL	PrintCRLF

		POP	BP
		POP	DI
		POP	SI
		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET

       Dump_AX:	CALL	PrintTAB
		CALL	PrintHEX
		CALL	PrintTAB
		CALL	PrintUnsigned
		CALL	PrintTAB
		CALL	PrintSigned
		CALL	PrintCRLF
		RET
PrintDump	ENDP

;---------------------------------------;
; Random_Seed := 1
;---------------------------------------;

Random_Initialize PROC	NEAR
		  MOV	Random_Seed,1
		  RET
Random_Initialize ENDP

;---------------------------------------;
; Random_Seed := <HH,MM> + <SS,TT>
;---------------------------------------;

Random_Randomize PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX

		MOV	AH,2CH		; Get Time
		INT	21H		; CH=HH, CL=MM, DH=SS, DL=TT

		MOV	AX,CX
		ADD	AX,DX
		CALL	Random_Set_Seed

		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
Random_Randomize ENDP

;---------------------------------------;
; Random_Seed := AX (but never zero)
;---------------------------------------;

Random_Set_Seed	PROC	NEAR
		PUSH	AX
		OR	AX,AX
		JNE	Do_Set_Seed
		INC	AX
   Do_Set_Seed:	MOV	Random_Seed,AX
		POP	AX
		RET
Random_Set_Seed	ENDP

;---------------------------------------;
; AX := Random (in range 1..65535)
;---------------------------------------;

Random_Get_New	PROC	NEAR
		PUSH	BX
		PUSH	DX

		MOV	BX,0
		MOV	AX,Random_Seed

		TEST	AX,0001H
		JZ	RanBit1
		NOT	BX
       RanBit1:
		TEST	AX,0002H
		JZ	RanBit2
		NOT	BX
       RanBit2:
		TEST	AX,0008H
		JZ	RanBit3
		NOT	BX
       RanBit3:
		TEST	AX,1000H
		JZ	RanBit4
		NOT	BX
       RanBit4:

		SHR	BX,1
		RCR	AX,1

		MOV	Random_Seed,AX

		POP	DX
		POP	BX
		RET
Random_Get_New	ENDP

;---------------------------------------;
; AL := Upper_Case(AL)			;
;---------------------------------------;

Upper_Case	PROC	NEAR
		CMP	AL,'a'
		JL	Upper_Done
		CMP	AL,'z'
		JG	Upper_Done
		AND	AL,0DFH
Upper_Done:	RET
Upper_Case	ENDP


;---------------------------------------;
; AL := Lower_Case(AL)			;
;---------------------------------------;

Lower_Case	PROC	NEAR
		CMP	AL,'A'
		JL	Lower_Done
		CMP	AL,'Z'
		JG	Lower_Done
		OR	AL,020H
Lower_Done:	RET
Lower_Case	ENDP


;---------------------------------------;
; AX := Square_Root(AX)			;
;					;
; Unsigned version uses all 16 bits	;
; Signed returns AX=0, C=1 if AX<0	;
;---------------------------------------;

SQRT_Signed	PROC	NEAR
		OR	AX,AX
		JNS	SQRT_OK
		XOR	AX,AX
		STC
		RET
       SQRT_OK:	CALL	SQRT_Unsigned
		CLC
		RET
SQRT_Signed	ENDP

;---------------------------------------;

SQRT_Unsigned	PROC	NEAR
		PUSH	BX
		PUSH	CX
		PUSH	DX

		XOR	BX,BX
		XOR	CX,CX
		MOV	DX,1

     SQRT_Loop:	ADD	CX,DX
		CMP	CX,AX
		JA	SQRT_Done
		INC	BX
		ADD	DX,2
		CMP	BX,255
		JL	SQRT_Loop
     SQRT_Done:	MOV	AX,BX

		POP	DX
		POP	CX
		POP	BX
		RET
SQRT_Unsigned	ENDP

;---------------------------------------;
;					;
;---------------------------------------;

		END
